/// <reference types="./update-query-node.d.ts" />
import { freeze } from '../util/object-utils.js';
/**
 * @internal
 */
export const UpdateQueryNode = freeze({
    is(node) {
        return node.kind === 'UpdateQueryNode';
    },
    create(table, withNode) {
        return {
            kind: 'UpdateQueryNode',
            table,
            ...(withNode && { with: withNode }),
        };
    },
    cloneWithUpdates(updateQuery, updates) {
        return freeze({
            ...updateQuery,
            updates: updateQuery.updates
                ? freeze([...updateQuery.updates, ...updates])
                : updates,
        });
    },
});
